/*-------------------------------------------------------------------------*
 * browser.c
 *
 * Michael Geikowski, 21.6.93
 *
 * TLA+ Browser Hauptmodul : Initialisierung & Aufruf des MainEventLoop
 *-------------------------------------------------------------------------*/
/*-------------------------------------------------------------------------*
 *
 * Ergaenzung : Olaf Meier, 18.09.94
 * Schnellstart - Routine hinzugefuegt.
 * Topmodulname als Auffrufparameter sorgt fuer den automatischen Start
 * einer neuen Browser-Sitzung.
 *--------------------------------------------------------------------------*/ 


#include <new.h>
#include <stdio.h>
#include <stdlib.h>

#include "topwin.h"
#include "dbinterface.h"

#include <Xm/Xm.h>
#include <Xm/MwmUtil.h>

static Widget       toplevel;
static XtAppContext context;

static void OutOfMemory()
 { 
 fprintf(stderr,"Sorry, out of memory\n");
 fflush(stderr);
 exit(-1);
 }

main (int argc,char* argv[])
 {
 Arg al[10];
 int ac;
 int fun;
 char* specname = NULL; 
 String fallbacks[] = 
 { "*modwintext.fontList:*fixed*bold*normal*13*",
   "*modwinlist.fontList:*fixed*bold*normal*13*",
   "*PTdialog.buttonFontList:*fixed*medium*normal*8*",
   "*modwinshell.x:400",
   "*navwinshell.x:20",
   "*navwinshell.y:550",
   NULL 
 };

 set_new_handler(OutOfMemory);	// Error Handler init
 standalone = 0;         	// dbinterface auf Browser Betrieb
 if(argc > 1)  // Name des Topmoduls ist angegeben... 
  { 
    specname = new char[strlen(argv[argc-1]) + 1];
    strcpy(specname, argv[argc-1]);
  }
 ac=0;				// Toplevel Widget init
 XtSetArg(al[ac],XmNtitle,"tTLA+ Browser"); ac++;
 toplevel=XtAppInitialize(&context,"Browser",0,0,&argc,argv,fallbacks,al,ac);
 
 CreateTopWin(toplevel,context); // Hauptfenster aufbauen

 XtRealizeWidget(toplevel);
 if(specname)
  { 
    QuickStart(specname);  // neue Sitzung starten
    delete specname;
  }

 XtAppMainLoop(context);	// Starte Hauptschleife
 }
