/*----------------------------------------------------------------------*
 * CrossRef.c
 *
 * Michael Geikowski, 14.6.93
 *
 * Enthaelt die Member-Funktionen der Klasse CrossRef.
 *----------------------------------------------------------------------*/
/*-----------------------------------------------------------------------*
 * Ergaenzungen: Olaf Meier, 1.9.94
 * 
 * Zusaetzliche Memberroutine GetParsetree(), sowie zusaetzliche Parameter
 * bei vorhanden Routinen.
 *-----------------------------------------------------------------------*/
#include <assert.h>
#include <string.h>

#include "crossref.h"

class CrossRefListElem : public ListElem
//======================================
	// Hilfsklasse zur Klasse CrossRef
 {
 public:

   CrossRefListElem(char* filename, SymListElem* name, Module_Type type,
                    SymList* s, SymList* export,ParseExpr* tree, SymList* secopy) 
 //----------------------------------------------------------------------
	:FileName(filename), ModName(name), ModType(type), sList(s),
         ExportList(export), Parsetree(tree), sListcopy(secopy)
	{}

   ~CrossRefListElem()
 //-------------------
	{ 
          delete sList;
          delete ExportList;
          delete Parsetree;
          delete sListcopy;
           }  

   char*        FileName;
   SymListElem* ModName;
   Module_Type  ModType;
   SymList*     sList;
   SymList*     ExportList;
   ParseExpr*   Parsetree;
   SymList*     sListcopy;
   
 };

/*----------------------------------------------------------------------*
 * Klasse CrossRef
 *----------------------------------------------------------------------*/

void CrossRef::Insert(char* filename, SymListElem* name, Module_Type type,
                      SymList* s, SymList* export,ParseExpr* ptree,SymList* symbcopy)
 {
 assert(name && s && export && ptree && symbcopy);
 NewFirstElem( new CrossRefListElem(filename, name, type, s, export,ptree,symbcopy) ); //om-> Parsetree
 }



SymList* CrossRef::Import(SymListElem* name,
                             SymListElem* qual, Module_Type *mt)
 {
 SymList* s;
 SymListElem *se, *e;
 CrossRefListElem *cre;

 assert(name);
 cre = (CrossRefListElem*) GetFirstElem();	// Eintrag zu Modul `name'
 while (cre)					// suchen
   {
   if (strcmp(name->Getlexem(),cre->FileName)==0)
     {
     break;
     }
   cre = (CrossRefListElem*) GetNextElem();
   }
 if (! cre)
   {
   return 0;					// Modul unbekannt
   }
 if (cre->ModName)
   name->SetDefinedAt(cre->ModName);		// Modulname im Definition
 						// verknuepfen
 *mt = cre->ModType;
 s   = new SymList;
 se  = cre->ExportList->GetFirstElem();		// Exportliste durchlaufen und
 while (se)					// neue Liste aller - evtl.
   {						// qualifizierter - Bezeichner
   e = se->copy();				// aufbauen
   if (qual && (e->Get_nidt()!=nidt_formalPar)
            && (e->Get_nidt()!=nidt_formalglobPar)
            && (e->Get_nidt()!=nidt_qualifier)  )
     {
     e->AddQualifier(qual);
     }
   s->Append(e);
   se = cre->ExportList->GetNextElem();
   }
 return s;
 }

void CrossRef::WriteLinkFiles()
 {
 CrossRefListElem *cre;

 cre = (CrossRefListElem*) GetFirstElem();	// Alle Module durchlaufen
 while (cre)
   {						// Je Modul eine Link-Datei
   cre->sList->WriteLinkFile(cre->FileName);
   cre = (CrossRefListElem*) GetNextElem();
   }
 }

 ParseExpr* CrossRef::GetParseTree(char* modname)
 {
 CrossRefListElem *cre;
 cre = (CrossRefListElem*) GetFirstElem();      //  nach Modulname suchen 
 while (cre)
  {
    if(strcmp(cre->ModName->Getlexem(),modname) == 0)
      return (cre->Parsetree);

    cre = (CrossRefListElem*) GetNextElem();
  }
 return NULL;
 }
