/*----------------------------------------------------------------------*
 * Layout.h
 *
 * Michael Geikowski, 26.3.93
 *
 * Erstellt Layout des Modul-Hierarchie-Graphen
 *----------------------------------------------------------------------*/
/* Ergaenzung : Olaf Meier, 26.8.94
 * Neue Routine VarLayout(), die das Layout des Systemvariablen-Baums
 * erstellt.
 *-----------------------------------------------------------------------*/

#include "adjlistgnu.h"
#include "higraphgnu.h"

HiGraph* Layout(AdjList *al, char* filename);
//-------------------------------------------
	// Erstellt das Layout des Modul-Graphen, der durch die Adjazenzlisten-
        // Darstellung `al' uebergeben wird. Das Layout wird als ASCII-Datei
        // unter dem Namen `filename' in der Datenbasis abgelegt. Rueckgabe
        // ist die Darstellung des Graphen als Hierarchie-Graph 'HiGraph' oder
        // Null, wenn Eingabegraph zyklisch ist.



HiGraph* VarLayout(AdjList *al, char* filename);
//---------------------------------------------
       // Erstellt das Layout des Systemvariablenbaums, der durch die Adjazenzlisten-
        // Darstellung `al' uebergeben wird. Das Layout wird als ASCII-Datei
        // unter dem Namen `filename' in der Datenbasis abgelegt. Rueckgabe
        // ist die Darstellung des Baumes als Hierarchie-Graph 'HiGraph' oder
        // Null, wenn Eingabegraph zyklisch ist.
                                                      
