/*----------------------------------------------------------------------*
 * PQueue.c
 *
 * Michael Geikowski, 22.3.93
 *
 * Enthaelt die Member-Funktionen der Klasse PQueue
 *----------------------------------------------------------------------*/

#include <assert.h>

#include "pqueuegnu.h"

PQueue::PQueue(int NrOfElems)
 {
 assert(NrOfElems > 0);
 Elems        = 0 ;
 MaxNrOfElems = NrOfElems;
 theQueue     = new QueueElem[NrOfElems];
 }

PQueue::~PQueue()
 {
 delete [ MaxNrOfElems ] theQueue;
 }

void PQueue::Insert(Node* n, float prio)
	// Element einfuegen. Queue als Heap im Array realisiert.
 {
 int       p,q;
 QueueElem *elar;

 assert(MaxNrOfElems > Elems);
 Elems++;
 elar = theQueue;
 p    = Elems;
 q    = p / 2;
 while ( (p != 1) && (elar[q-1].prio < prio) ) 
  {
  elar[p-1] = elar[q-1];
  p = q;
  q = p / 2;
  }
 elar[p-1].prio    = prio;
 elar[p-1].theNode = n;
 }

Node* PQueue::DeleteMax()
	// Element loeschen. Queue als Heap im Array realisiert.
 {
 int       p,q,r;
 QueueElem *elar;
 Node*     n;

 assert (Elems > 0);
 elar = theQueue;
 n    = elar[0].theNode;
 p    = 1;
 while (1)
  {
  q = 2*p;
  r = 2*p+1;
  if ( q > Elems )
    {
    break;
    }
  else if ( ( r > Elems ) ||
            ( elar[r-1].prio < elar[q-1].prio ) )
    {
    if ( elar[Elems-1].prio < elar[q-1].prio )
      {
      elar[p-1] = elar[q-1];
      p = q;
      }
    else
      {
      break;
      }
    }
  else
    {
    if ( elar[Elems-1].prio < elar[r-1].prio )
      {
      elar[p-1] = elar[r-1];
      p = r;
      }
    else
      {
      break;
      }
    }
  }
 elar[p-1] = elar[Elems-1];
 Elems--;
 return (n);
 }
