TEMPORAL MODULE Echo

  PARAMETERS Node      : Any           CONSTANT;
             Edge      : Node :X: Node CONSTANT;
             Initiator : Node          CONSTANT; 

  INCLUDE EchoActions AS EA(MR,S,TS,QF,MS,MB)
     WITH Marker    <- MR,
          Success   <- S,
          ToScan    <- TS,
          QFrom     <- QF,
          Master    <- MS,
          MBox      <- MB,
          Node      <- Node,
          Edge      <- Edge,
          Initiator <- Initiator;

  TEMPORAL THEOREMS
    Echo == 
      :EE: MR,S,TS,QF,MS,MB
       :: /\ EA(MR,S,TS,QF,MS,MB).Init
          /\ [] ( [ :E: v,w :in: Node
                     :: \/ EA(MR,S,TS,QF,MS,MB).SendScan(v,w)
                        \/ EA(MR,S,TS,QF,MS,MB).ReceiveFirstScan(v)
                        \/ EA(MR,S,TS,QF,MS,MB).ReceiveSucc(v)
                        \/ EA(MR,S,TS,QF,MS,MB).SendReply(v)
                        \/ EA(MR,S,TS,QF,MS,MB).InitiatorDetectsTermination(v)
                  ] _ (MR,S,TS,QF,MS,MB)
                )
          /\ :A: v,w :in: Node 
              :: /\ WF [ (MR,S,TS,QF,MS,MB) ] 
                       ( EA(MR,S,TS,QF,MS,MB).SendScan(v,w) )
                 /\ WF [ (MR,S,TS,QF,MS,MB) ] 
                       ( EA(MR,S,TS,QF,MS,MB).ReceiveFirstScan(v) )
                 /\ WF [ (MR,S,TS,QF,MS,MB) ] 
                       ( EA(MR,S,TS,QF,MS,MB).ReceiveSucc(v) )
                 /\ WF [ (MR,S,TS,QF,MS,MB) ] 
                       ( EA(MR,S,TS,QF,MS,MB).SendReply(v) )
                 /\ WF [ (MR,S,TS,QF,MS,MB) ] 
                       ( EA(MR,S,TS,QF,MS,MB).InitiatorDetectsTermination(v) )
    ;

END Echo
