CONSTANT MODULE Tables

(* Tables.t - status: accepted, expanded               *)
(* originally from Lamports 9/91 TLA+ text, adapted to *)
(* 2/92 and to Dortmund-Syntax, Mester, 9.7.92         *)

PARAMETERS Name, Item;

CONSTANTS
  Entry  ==  [[nam : Name; itm : Item]];
  Table  ==  {T | T :in: SUBSET( Entry ) :
                  :A: s,t :in: T :: s.nam = t.nam  =>  s = t
             };
  
  EmptyTable == :emptyset: ;
  
  Insert(n, i, T)  == 
      {t | t :in: T : t.nam # n} :cup: { [[nam :mapsto: n, itm :mapsto: i]]} ;
  
  LookUp(n, T)  ==  CHOOSE( t :in: T : t.nam = n ).itm ;
  
BOOLEANS
  InTable(n, T)  ==  :E: t :in: T :: t.nam = n
  ;
  
THEOREMS
  TableTypeOK  == 
     /\ EmptyTable :in: Table
     /\ :A: n :in: Name; T :in: Table 
           ::  /\ InTable(n, T) => LookUp(n, T) :in: Item
               /\ :A: i :in: Item :: Insert(n, i, T) :in: Table
  ;

END Tables 
 
