MODULE WireArrays
(* originally from Lamports 9/91 TLA+ text, adapted to             *)
(* 2/92 and to Dortmund-Syntax: Mester, 9.7.92; Geikowski, 18.5.93 *)

PARAMETERS Name  : Any  CONST;       (* The names of the wires.       *)
           wires : Type STATE FCN;   (* The array of wires.           *)

INCLUDE Wire AS Single;

CONSTANTS
  Type  ==  SET [Name -> Single.Type];
  
PREDICATES
  Init  ==  :A: n :in: Name :: Single.Init(wires[n]) 
  ;
  
ACTIONS  
  ChangeOnly(n : Name)  ==  
    /\ DOMAIN( Type ) = Name
    /\ :A: x :in: Name :: x # n => wires'[x] = wires[x]
  ;
  Send(i : Item; n : Name) == /\ ChangeOnly(n)
                              /\ Single.Send(wires[n],i)
  ;
  Rcv(i : Item; n : Name)  == /\ ChangeOnly(n)
                              /\ Single.Rcv(wires[n],i)
  ;

END
