TEMPORAL MODULE myElevator

  IMPORT myElevatorDefs;

  INCLUDE myService AS Ser(Li,Lo,Di) WITH Light    <- Li,
                                        Location <- Lo,
                                        Direction<- Di,
                                        TopFloor <- TopFloor;

  INCLUDE myLift AS Lif(Li,Lo,Di) WITH Light    <- Li,
                                     Location <- Lo,
                                     Direction<- Di,
                                     TopFloor <- TopFloor;

  TEMPORAL THEOREMS
    Elevator == :EE: Light, Location, Direction
                 ::
                     /\ Ser(Light,Location,Direction).Init
                     /\ [] ([
                             \/ :E: f :in: Floor
                                :: Ser(Light,Location,Direction).PressButton(f)
                             \/ Lif(Light,Location,Direction).MoveUp
                             \/ Lif(Light,Location,Direction).MoveDown
                            ] _ (Light,Location,Direction)
                           )
                     /\ :A: f :in: Floor 
                         :: Light[f] = "on" :leadsto: Light[f] = "off"
    ;

END myElevator
